dofile("script/timing.lua")
dofile("script/player.lua")
dofile("script/npc.lua")
dofile("script/pattern.lua")

function Center(text, yOffset, body, fontset, z)
	yOffset = yOffset or 0
	body = body or staticBody
	fontset = fontset or util.defaultFontset
	local pos = vector.Offset(util.TextCenter(text, fontset), 0, yOffset)
	return util.PrintOrange(pos, text, z or 0, body, 0.02, fontset)
end

local function Scale(tile)
	eapi.SetPos(tile, vector.Scale(eapi.GetPos(tile), 0.7))
	eapi.SetSize(tile, vector.Scale(eapi.GetSize(tile), 0.7))
end

local titleBody = eapi.NewBody(gameWorld, vector.null)
local title = "Censored by the order of the King"
util.Map(Scale, Center(title, 280, titleBody, util.bigFontset))
local word = "\"Use of C-word in titles of video games is strictly forbidden!\""
Center(word, 160, titleBody, util.defaultFontset)

local infoBody = eapi.NewBody(gameWorld, vector.null)
local info = "Use arrow keys to avoid being crushed ;)"
Center(info, -220, infoBody, util.defaultFontset)

local function DestroyText()
	eapi.Destroy(titleBody)
	eapi.Destroy(infoBody)
	npc.GoKing()
end

player.RemoveText = function()
	eapi.SetVel(infoBody, { x = 0, y = -30 })
	eapi.SetVel(titleBody, { x = 0, y = 60 })
	eapi.AddTimer(staticBody, 1.5, DestroyText)
end

local function Score()
	if player.hits == 0 then 
		return "Fuck you King! Choke on your Candy."
	else
		return "You have been crushed " .. player.hits .. " times."
	end
end

timing.EndText = function()
	local endBody = eapi.NewBody(gameWorld, { x = 0, y = 280 })
	Center("The End", 0, endBody, util.bigFontset, 300)
	eapi.SetVel(endBody, { x = 0, y = -280 })

	local bottomBody = eapi.NewBody(gameWorld, { x = 0, y = -280 })
	Center(Score(), 16, bottomBody, util.defaultFontset, 300)
	local thankYou = "Thank you for playing!"
	Center(thankYou, 0, bottomBody, util.defaultFontset, 300)
	local esc = "Press ESC to quit."
	Center(esc, -16, bottomBody, util.defaultFontset, 300)
	eapi.SetVel(bottomBody, { x = 0, y = 224 })

	local function Stop()
		eapi.SetVel(endBody, vector.null)
		eapi.SetVel(bottomBody, vector.null)
	end

	eapi.AddTimer(staticBody, 1.0, Stop)
end

npc.King()
player.Create()
