local index = 0
local nextTimer = nil
local reference = nil
local patternList = { }

local function DummyBody()
	return eapi.NewBody(gameWorld, vector.null)
end

local function NewReference()
	reference = DummyBody()
	return reference
end

local function Init(list)
	patternList = list
	NewReference()
end

local function NextTimer()
	nextTimer = eapi.AddTimer(reference, player.timeout, timing.Advance)
	player.Reset()
end

local function Reset()
	if nextTimer then
		eapi.CancelTimer(nextTimer)
		NextTimer()
	end
end

local function DeleteLolly(obj)
	if obj.class == "Lolly" then actor.Delete(obj) end
end

local function Sweep()
	local ttl = 0.5
	util.Map(DeleteLolly, util.CopyTable(actor.store))
	local tile = actor.FillScreen(util.white, 2000, util.Gray(1.0))
	eapi.AnimateColor(tile, eapi.ANIM_CLAMP, util.invisible, ttl, 0)
	eapi.AddTimer(staticBody, ttl, function() eapi.Destroy(tile) end)
	eapi.PlaySound(gameWorld, "sound/sigh.ogg")
end

local function Advance(sweep)
	nextTimer = nil
	index = index + 1
	eapi.Destroy(reference)
	if sweep ~= "no" then Sweep() end
	local pattenFn = patternList[index]
	if pattenFn then
		NewReference()
		NextTimer()
		pattenFn(reference)
	else
		timing.EndText()
		player.Pause()
	end
end

local function Pause()
	if nextTimer then
		eapi.CancelTimer(nextTimer)
		player.Pause()
	end
end

local function Delay(delay)
	return function(body)
		util.Delay(body, delay, Advance, "no")
		Pause()
	end
end

timing = {
	Init = Init,
	Reset = Reset,
	Delay = Delay,
	Pause = Pause,
	Advance = Advance,
	Resume = NextTimer,
}
